zipios::DeflateOutputStreambuf Class Reference

DeflateOutputStreambuf is an output stream filter, that deflates the data that is written to it before it passes it on to the output stream it is attached to. More...

`#include <deflateoutputstreambuf.h>`

Inheritance diagram for zipios::DeflateOutputStreambuf:
[legend]

## Public Member Functions

| DeflateOutputStreambuf (streambuf *outbuf, bool user_init=false, bool del_outbuf=false)
| DeflateOutputStreambuf constructor.
virtual | ~DeflateOutputStreambuf ()
| Destructor.
bool | init (int comp_level=6)
bool | closeStream ()
uint32 | getCrc32 () const
| Returns the CRC32 for the current stream.
uint32 | getCount () const
| Returns the number of bytes written to the streambuf, that has been processed from the input buffer by the compressor.
Public Member Functions inherited from zipios::FilterOutputStreambuf
| FilterOutputStreambuf (streambuf *outbuf, bool del_outbuf=false)
| Constructor.
virtual | ~FilterOutputStreambuf ()
| Destructor.

## Protected Member Functions

virtual int | overflow (int c=EOF)
virtual int | sync ()
bool | flushOutvec ()
| Flushes _outvec and updates _zs.next_out and _zs.avail_out.
void | endDeflation ()
| Flushes the remaining data in the zlib buffers, after which the only possible operations are deflateEnd() or deflateReset().

## Protected Attributes

const int | _invecsize
vector< char > | _invec
const int | _outvecsize
vector< char > | _outvec
uint32 | _crc32
uint32 | _overflown_bytes
Protected Attributes inherited from zipios::FilterOutputStreambuf
streambuf * | _outbuf
bool | _del_outbuf

## Detailed Description

DeflateOutputStreambuf is an output stream filter, that deflates the data that is written to it before it passes it on to the output stream it is attached to.

Deflation/Inflation is a compression/decompression method used in gzip and zip. The zlib library is used to perform the actual deflation, this class only wraps the functionality in an output stream filter.

Definition at line 25 of file deflateoutputstreambuf.h.

## Constructor & Destructor Documentation

## DeflateOutputStreambuf()

zipios::DeflateOutputStreambuf::DeflateOutputStreambuf | ( | streambuf * | outbuf,
|  | bool | user_init = false,
|  | bool | del_outbuf = false )

explicit

DeflateOutputStreambuf constructor.

Parameters

  outbuf | the streambuf to use for output.
  user_init | If false user must invoke init() before writing any data. (ZipOutputStreambuf needs to do this)
  del_outbuf | if true is specified outbuf will be deleted, when the DeflateOutputStreambuf is destructed.

Definition at line 18 of file deflateoutputstreambuf.cpp.

## ~DeflateOutputStreambuf()

zipios::DeflateOutputStreambuf::~DeflateOutputStreambuf | ( |  | ) |

virtual

Destructor.

Definition at line 43 of file deflateoutputstreambuf.cpp.

## Member Function Documentation

## closeStream()

bool zipios::DeflateOutputStreambuf::closeStream | ( |  | ) |

Definition at line 88 of file deflateoutputstreambuf.cpp.

## endDeflation()

void zipios::DeflateOutputStreambuf::endDeflation | ( |  | ) |

protected

Flushes the remaining data in the zlib buffers, after which the only possible operations are deflateEnd() or deflateReset().

Definition at line 173 of file deflateoutputstreambuf.cpp.

## flushOutvec()

bool zipios::DeflateOutputStreambuf::flushOutvec | ( |  | ) |

protected

Flushes _outvec and updates _zs.next_out and _zs.avail_out.

Definition at line 162 of file deflateoutputstreambuf.cpp.

## getCount()

uint32 zipios::DeflateOutputStreambuf::getCount | ( |  | ) | const

inline

Returns the number of bytes written to the streambuf, that has been processed from the input buffer by the compressor.

After closeStream() has been called this number is the total number of bytes written to the stream.

Definition at line 55 of file deflateoutputstreambuf.h.

## getCrc32()

uint32 zipios::DeflateOutputStreambuf::getCrc32 | ( |  | ) | const

inline

Returns the CRC32 for the current stream.

The returned value is the CRC for the data that has been compressed already (due to a call to overflow()). As DeflateOutputStreambuf may buffer an arbitrary amount of bytes until closeStream() has been invoked, the returned value is not very useful before closeStream() has been called.

Definition at line 49 of file deflateoutputstreambuf.h.

## init()

bool zipios::DeflateOutputStreambuf::init | ( | int | comp_level = 6 | ) |

Definition at line 51 of file deflateoutputstreambuf.cpp.

## overflow()

int zipios::DeflateOutputStreambuf::overflow | ( | int | c = EOF | ) |

protected virtual

Definition at line 109 of file deflateoutputstreambuf.cpp.

## sync()

int zipios::DeflateOutputStreambuf::sync | ( |  | ) |

protected virtual

Definition at line 155 of file deflateoutputstreambuf.cpp.

## Member Data Documentation

## _crc32

uint32 zipios::DeflateOutputStreambuf::_crc32

protected

Definition at line 77 of file deflateoutputstreambuf.h.

## _invec

vector< char > zipios::DeflateOutputStreambuf::_invec

protected

Definition at line 73 of file deflateoutputstreambuf.h.

## _invecsize

const int zipios::DeflateOutputStreambuf::_invecsize

protected

Definition at line 72 of file deflateoutputstreambuf.h.

## _outvec

vector< char > zipios::DeflateOutputStreambuf::_outvec

protected

Definition at line 75 of file deflateoutputstreambuf.h.

## _outvecsize

const int zipios::DeflateOutputStreambuf::_outvecsize

protected

Definition at line 74 of file deflateoutputstreambuf.h.

## _overflown_bytes

uint32 zipios::DeflateOutputStreambuf::_overflown_bytes

protected

Definition at line 78 of file deflateoutputstreambuf.h.

The documentation for this class was generated from the following files:

- deflateoutputstreambuf.h
- deflateoutputstreambuf.cpp